//Serena Bailey ITDEV140 Downtown Campus AM
package bailey_monstermash;

import java.util.Random;
import java.util.Scanner;
import javax.sound.sampled.LineUnavailableException;

/**
 *
 * @author sailo
 */
public class Controller {
    
        //declarations for all of my monsters.
        Monster myMonster;
        Gelatoni cat;
        Draconis dragon;
        Harvey ghost;
        Delvetica daemon;
        
        //dice for determining which monster will be fighting and which will win.
        Random random = new Random();
        int dice1 = random.nextInt(4) + 1;
        int dice2 = random.nextInt(4) + 1;

    public void MeetTheMonsters() throws InterruptedException, LineUnavailableException
    {
        //monsters with base information.
        myMonster = new Monster("Monster", 0, 0, "Name");
        cat = new Gelatoni("Werecat", 50, 50, "Gelatoni", "Adorable");
        dragon = new Draconis("Dragon", 70, 20, "Draconis", "Red");
        ghost = new Harvey("Poltergeist", 80, 25, "Harvey", "Green Isles");
        daemon = new Delvetica("Daemon", 90, 10, "Delvetica", "Expert");
    
        Gelatoni obj = cat;         //here is where all of the information for the mosters will show.
        showGelatoni(obj);
        
        Draconis obj1 = dragon;
        showDraconis(obj1);
        
        Harvey obj2 = ghost;
        showHarvey(obj2);
        
        Delvetica obj3 = daemon;
        showDelvetica(obj3);
    
        View v = new View();        //prompt after the monsters information shows.
        v.gameOptions();
    }
    
    public void showGelatoni(Gelatoni obj)
    {
        System.out.println("\nMonster Type: \t\t" + obj.getType());
        System.out.println("Scare Factor: \t\t" + obj.getScareFactor() + "/100");
        System.out.println("Monster Speed: \t\t" + obj.getSpeed() + "MPH");
        System.out.println("Monster Name: \t\t" + obj.getName());
        System.out.println("Monster Cuteness: \t" + obj.getCuteFactor());
        System.out.println("Monster Sound: \t\t" + obj.speak());
    }
    
    public void showDraconis(Draconis obj1)
    {
        System.out.println("\nMonster Type: \t\t" + obj1.getType());
        System.out.println("Scare Factor: \t\t" + obj1.getScareFactor() + "/100");
        System.out.println("Monster Speed: \t\t" + obj1.getSpeed() + "MPH");
        System.out.println("Monster Name: \t\t" + obj1.getName());
        System.out.println("Monster Color: \t\t" + obj1.getColor());
        System.out.println("Monster Sound: \t\t" + obj1.speak());
    }
    
    public void showHarvey(Harvey obj2)
    {
        System.out.println("\nMonster Type: \t\t" + obj2.getType());
        System.out.println("Scare Factor: \t\t" + obj2.getScareFactor() + "/100");
        System.out.println("Monster Speed: \t\t" + obj2.getSpeed() + "MPH");
        System.out.println("Monster Name: \t\t" + obj2.getName());
        System.out.println("Monster Location: \t" + obj2.getorigin());
        System.out.println("Monster Sound: \t\t" + obj2.speak());
    }
    
    public void showDelvetica(Delvetica obj3)
    {
        System.out.println("\nMonster Type: \t\t" + obj3.getType());
        System.out.println("Scare Factor: \t\t" + obj3.getScareFactor() + "/100");
        System.out.println("Monster Speed: \t\t" + obj3.getSpeed() + "MPH");
        System.out.println("Monster Name: \t\t" + obj3.getName());
        System.out.println("Magic Proficiency: \t" + obj3.getMagicPower());
        System.out.println("Monster Sound: \t\t" + obj3.speak());
    }
    
    public void battleMonsters() throws InterruptedException, LineUnavailableException
    {
        //Where the monsters battle information is stored to determine which monster will be battling.
        //All is based on if statements.
        System.out.println("\n\nLet's roll the dice to see which monsters will be battling!");
        System.out.println("You rolled: " + dice2 + " and a " + dice1 + ". So you'll be battling; ");
        
        if(dice1 == 1)
        {
            cat = new Gelatoni("Werecat", 50, 50, "Gelatoni", "Adorable");
            Gelatoni obj = cat;
            showGelatoni(obj);
            System.out.println(".. is Monster #1");
        }
        
        if(dice2 == 1)
        {
            cat = new Gelatoni("Werecat", 50, 50, "Gelatoni", "Adorable");
            Gelatoni obj = cat;
            showGelatoni(obj);
            System.out.println(".. is Monster #2");
        }
        
        if(dice1 == 2)
        {
            dragon = new Draconis("Dragon", 70, 20, "Draconis", "Red");
            Draconis obj1 = dragon;
            showDraconis(obj1);
            System.out.println(".. is Monster #1");
        }
        
        if (dice2 == 2)
        {
            dragon = new Draconis("Dragon", 70, 20, "Draconis", "Red");
            Draconis obj1 = dragon;
            showDraconis(obj1);
            System.out.println(".. is Monster #2");
        }
        
        if (dice1 == 3)
        {
            ghost = new Harvey("Poltergeist", 80, 25, "Harvey", "Green Isles");
            Harvey obj2 = ghost;
            showHarvey(obj2);
            System.out.println(".. is Monster #1");
        }
        
        if (dice2 == 3)
        {
            ghost = new Harvey("Poltergeist", 80, 25, "Harvey", "Green Isles");
            Harvey obj2 = ghost;
            showHarvey(obj2);
            System.out.println(".. is Monster #2");
        }
        
        if (dice1 == 4)
        {
            daemon = new Delvetica("Daemon", 90, 10, "Delvetica", "Expert");
            Delvetica obj3 = daemon;
            showDelvetica(obj3);
            System.out.println(".. is Monster #1");
        }
        
        if (dice2 == 4)
        {
            daemon = new Delvetica("Daemon", 90, 10, "Delvetica", "Expert");
            Delvetica obj3 = daemon;
            showDelvetica(obj3);
            System.out.println(".. is Monster #2");
        }
        
        checkForWinner();
    }
        
    public void checkForWinner() throws InterruptedException, LineUnavailableException
    {
        //How to determine which monster wins is all based in the order of which each monster is made.
        //Each monster is placed in order and the order is based on the order of the dice. The higher the value, the better the chance it wins.
        if (dice1 > dice2)   
        {
            System.out.println("\nIt's easy to see, the winner is.. Monster #1!!");
        }
        if (dice1 == dice2)
        {
            System.out.println("\nLooks like they're evenly matched!");
        }
        if (dice1 < dice2)
        {
            System.out.println("\nLooks like the winner is.. Monster #2!!");
        }
            
        //prompting back to see if the user wants to see another battle, monster stats or quit.
        View v = new View();
        v.gameOptions();
    }
}
